> For the complete documentation index, see [llms.txt](https://docs.cspr.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cspr.cloud/1.4.x/rest-api/fungible-token-action/get-token-actions.md).

# Get fungible token actions

Get fungible token actions

```
GET /ft-token-actions
```

## Query params

| Property                | Description                                   |
| ----------------------- | --------------------------------------------- |
| `contract_package_hash` | Filter token actions by contract package hash |
| `account_hash`          | Filter token actions by account hash          |
| `from_block_height`     | From block height range                       |
| `to_block_height`       | To block height range                         |

## Sorting

| Property    | Description                              |
| ----------- | ---------------------------------------- |
| `timestamp` | Sort fungible token actions by timestamp |

Default sorting is `timestamp DESC`

## Optional properties

| Property                        | Type                                                                    | Description                                                                          |
| ------------------------------- | ----------------------------------------------------------------------- | ------------------------------------------------------------------------------------ |
| `contract_package`              | [`ContractPackage`](/1.4.x/rest-api/contract-package.md)                | Fungible contract package                                                            |
| `deploy`                        | [`Deploy`](/1.4.x/rest-api/deploy.md)                                   | Deploy in which the token action occurred                                            |
| `from_public_key`               | `string(68)`                                                            | Action source public key if it's an account                                          |
| `to_public_key`                 | `string(68)`                                                            | Action target public key if it's an account                                          |
| `to_account_info`               | [`AccountInfo`](/1.4.x/rest-api/account-info.md)                        | Action source account info if it's an account                                        |
| `to_centralized_account_info`   | [`CentralizedAccountInfo`](/1.4.x/rest-api/centralized-account-info.md) | Action target centralized account info if it's an account                            |
| `from_account_info`             | [`AccountInfo`](/1.4.x/rest-api/account-info.md)                        | Action target account info if it's an account                                        |
| `from_centralized_account_info` | [`CentralizedAccountInfo`](/1.4.x/rest-api/centralized-account-info.md) | Action target centralized account info if it's an account                            |
| `rate`                          | `float32`                                                               | CSPR rate for specified currency that was relevant at the moment of deploy creation. |
| `from_cspr_name`                | `string`                                                                | Primary CSPR.name of the source account, if it is an account                         |
| `to_cspr_name`                  | `string`                                                                | Primary CSPR.name of the destination account, if it is an account                    |

## Response

[`PaginatedResponse`](/1.4.x/documentation/overview/pagination.md)[`<FTTokenAction>`](/1.4.x/rest-api/fungible-token-action.md)

## Example

```bash
curl -X 'GET' \
  'https://api.testnet.cspr.cloud/accounts/B6C26649540C59DECBC53274A67336D0588F6AD2AE0863A8A636DDDCC75689F0/ft-token-actions' \
  -H 'accept: application/json' \
  -H 'authorization: 55f79117-fc4d-4d60-9956-65423f39a06a'
```

```json
{
  "data": [
    {
      "amount": "24928248069",
      "contract_package_hash": "0885c63f5f25ec5b6f3b57338fae5849aea5f1a2c96fc61411f2bfc5e432de5a",
      "deploy_hash": "0005f1e53afa9799a66a389a90caab84ab3cbd000ab7741e55e09f80c75002b6",
      "block_height": 1475677,
      "from_hash": null,
      "from_type": 1,
      "ft_action_type_id": 1,
      "timestamp": "2023-02-09T19:16:21Z",
      "to_hash": "b6c26649540c59decbc53274a67336d0588f6ad2ae0863a8a636dddcc75689f0",
      "to_type": 1,
      "transform_idx": 92
    },
    {
      "amount": "24928248069",
      "contract_package_hash": "0885c63f5f25ec5b6f3b57338fae5849aea5f1a2c96fc61411f2bfc5e432de5a",
      "deploy_hash": "0005f1e53afa9799a66a389a90caab84ab3cbd000ab7741e55e09f80c75002b6",
      "block_height": 1475677,
      "from_hash": "b6c26649540c59decbc53274a67336d0588f6ad2ae0863a8a636dddcc75689f0",
      "from_type": 1,
      "ft_action_type_id": 2,
      "timestamp": "2023-02-09T19:16:21Z",
      "to_hash": "a5a9a804a383f3b0e131c85d471542af2c6d4ec57bab39182ba93dd7bd86f46c",
      "to_type": 1,
      "transform_idx": 104
    },
    ...
    {
      "amount": "22894649700",
      "contract_package_hash": "0885c63f5f25ec5b6f3b57338fae5849aea5f1a2c96fc61411f2bfc5e432de5a",
      "deploy_hash": "00194e8c2076ae84447a8ccabf39ad1eb1a090ab4e592989fd497961fb0b7293",
      "block_height": 1461592,
      "from_hash": "b6c26649540c59decbc53274a67336d0588f6ad2ae0863a8a636dddcc75689f0",
      "from_type": 1,
      "ft_action_type_id": 4,
      "timestamp": "2023-02-04T10:52:19Z",
      "to_hash": null,
      "to_type": 1,
      "transform_idx": 147
    }
  ],
  "item_count": 97704,
  "page_count": 9771
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.cspr.cloud/1.4.x/rest-api/fungible-token-action/get-token-actions.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
